Flux.jl and the Flux ecosystem follow the [ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac). For best practices on getting started, check out that document.

We also suggest taking a look at the [Julia Ecosystem contributing guide](https://julialang.org/contribute/) which goes over higher level topics like why you should contribute, different contribution pathways, and more! 

## Help Wanted Issues

One of the best ways to contribute is by looking at issues labeled ["help wanted"](https://github.com/FluxML/Flux.jl/labels/help%20wanted). These issues are not always very beginner friendly but you are welcome to ask clarifying questions or just browse them to see if there is anything that seems interesting to help with. 

## Good First Issues

While there are not many right now, we do have a section for ["good for issues"](https://github.com/FluxML/Flux.jl/labels/good%20first%20issue). As mentioned above, if any of these seem interesting but there is no clear next step in your mind, please feel free to ask for a suggested step. Often times in open source, issues labeled as "good first issue" actually take some back and forth between maintainers and contributors before the issues is ready to be tackled by a new contributor.

## Model Zoo

If you are already using Flux to develop models, one way to give back to the community is by sharing models you have created in the [Model Zoo](https://github.com/FluxML/model-zoo). You can find out more in the [Model Zoo's README](https://github.com/FluxML/model-zoo#contributing). 

## Write Tutorials

Tutorials are an important part of making Deep Learning and Flux accessible to everyone. We already have some great ones on our website here: https://fluxml.ai/tutorials.html and welcome new ones, especially if they are beginner focused, of which beginners tend to write the best ones. A good first step is to find a tutorial you find helpful from another ecosystem and try to rewrite it using Flux (making sure to properly attribute and not plagiarize)

## Other ideas

We are open to contributions in all shapes and forms! If you have an idea, please suggest it and we will do our best to help you bring it to life!
